# encoding: UTF-8
#--
#
#################################################################################
# Copyright 2010-2013 Free Software's Seed, CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
class VPresupuestoDetallado < ActiveRecord::Base
  #untranslate_all
  # valores =  proyecto_id (0), moneda_id (1), implementador_id (2), fecha_inicio (3), fecha_fin (4), tasa_cambio (5)

  scope :partida_de_implementador, lambda { |*valores| {
                                 :select => "partida_id as fila_id, #{importe valores[1], valores[5]} as importe", 
                                 :group => "proyecto_id, partida_id #{moneda valores[1]}  #{agente valores[2], "implementador"} ",
                                 :conditions => condiciones(valores[0], valores[1], valores[2], valores[3], valores[4], "implementador")  } }


  scope :partida_de_financiador, lambda { |*valores| {
                                 :select => "partida_id as fila_id, #{importe valores[1], valores[5]} as importe", 
                                 :group => "proyecto_id, partida_id #{moneda valores[1]}  #{agente valores[2], "financiador"} ",
                                 :conditions => condiciones(valores[0], valores[1], valores[2], valores[3], valores[4], "financiador")  } }

  scope :actividad_de_implementador, lambda { |*valores| {
                                 :select => "actividad_id as fila_id, #{importe valores[1], valores[5]} as importe", 
                                 :group => "proyecto_id, actividad_id #{moneda valores[1]}  #{agente valores[2], "implementador"} ",
                                 :conditions => condiciones(valores[0], valores[1], valores[2], valores[3], valores[4], "implementador", :partida => valores[6])  } }
                                    
  scope :actividad_de_financiador, lambda { |*valores| {
                                 :select => "actividad_id as fila_id, #{importe valores[1], valores[5]} as importe", 
                                 :group => "proyecto_id, actividad_id #{moneda valores[1]}  #{agente valores[2], "financiador"} ",
                                 :conditions => condiciones(valores[0], valores[1], valores[2], valores[3], valores[4], "financiador", :partida => valores[6])  } }

  scope :partida_proyecto_de_implementador, lambda { |*valores| {
                                 :select => "partida_proyecto_id as fila_id, #{importe valores[1], valores[5]} as importe", 
                                 :group => "proyecto_id, partida_proyecto_id #{moneda valores[1]}  #{agente valores[2], "implementador"} ",
                                 :conditions => condiciones(valores[0], valores[1], valores[2], valores[3], valores[4], "implementador")  } }

                                    
  scope :partida_proyecto_de_financiador, lambda { |*valores| {
                                 :select => "partida_proyecto_id as fila_id, #{importe valores[1], valores[5]} as importe", 
                                 :group => "proyecto_id, partida_proyecto_id #{moneda valores[1]}  #{agente valores[2], "financiador"} ",
                                 :conditions => condiciones(valores[0], valores[1], valores[2], valores[3], valores[4], "financiador")  } }

  scope :partida_de_implementador_sin_proyecto, lambda { |*valores| {
                                 :select => "partida_id as fila_id, #{importe valores[0], valores[4]} as importe, proyecto_aprobado", 
                                 :group => "partida_id #{moneda valores[0]}  #{agente valores[1], "implementador"} ",
                                 :conditions => condiciones_sin_proyecto(valores[0], valores[1], valores[2], valores[3], "implementador", valores[5], valores[6])  } }


  scope :implementador_sin_proyecto, lambda { |*valores| {
                                 :select => "partida_nombre , #{importe valores[0], valores[4]} as importe, proyecto_nombre, presupuesto_id , presupuesto_concepto, partida_codigo, proyecto_aprobado", 
                                 :group => "presupuesto_id #{moneda valores[0]}  #{agente valores[1], "implementador"} ",
                                 :conditions => condiciones_sin_proyecto(valores[0], valores[1], valores[2], valores[3], "implementador", valores[5], valores[6]),
                                 :order => "partida_codigo"  } }


  scope :partida, lambda { |*valores| {
                                 :select => "#{importe valores[1], valores[5]} as importe", 
                                 :conditions => condiciones(valores[0], valores[1], valores[2], valores[3], valores[4], valores[6], :partida => valores [7])  } }

  scope :partida_proyecto, lambda { |*valores| {
                                 :select => "#{importe valores[1], valores[5]} as importe", 
                                 :conditions => condiciones(valores[0], valores[1], valores[2], valores[3], valores[4], valores[6], :partida_proyecto => valores [7])  } }


  scope :subpartida_partida, lambda { |*valores| {
                                 :select => "#{importe valores[1], valores[5] } as importe", 
                                 :conditions => condiciones( valores[0], valores[1], valores[2], valores[3], valores[4], valores[6], :partida => valores[7], :subpartida => (valores[8] || "isnull") ) } }

  scope :subpartida_partida_proyecto, lambda { |*valores| {
                                 :select => "#{importe valores[1], valores[5] } as importe", 
                                 :conditions => condiciones( valores[0], valores[1], valores[2], valores[3], valores[4], valores[6], :partida_proyecto => valores[7], :subpartida => (valores[8] || "isnull") ) } }



     
  def self.importe moneda_id, tasa_cambio
    importe = if  moneda_id == "todas";  "sum(importe_moneda_base)"
               elsif tasa_cambio == "0"; "sum(importe)"
               elsif tasa_cambio == "1"; "sum(importe_moneda_base)"; end
  end  

  def self.moneda moneda_id
      return moneda_id == "todas" ? "" : ", moneda_id "
  end

  def self.agente agente_id, agente_rol
      return agente_id == "todos" ? "" : ", #{agente_rol}_id "
  end

  def self.condiciones proyecto_id, moneda_id, agente_id, fecha_inicio, fecha_fin, agente_rol, otros={}
     condiciones = {"proyecto_id" => proyecto_id, "fecha_inicio" => fecha_inicio..fecha_fin, "fecha_fin" => fecha_inicio..fecha_fin }
     condiciones["moneda_id"] = moneda_id unless moneda_id == "todas"
     condiciones[agente_rol + "_id"] = agente_id unless agente_id == "todos"
     condiciones["partida_id"] = otros[:partida] if otros[:partida]
     condiciones["partida_proyecto_id"] = otros[:partida_proyecto] if otros[:partida_proyecto]
     condiciones["subpartida_id"] = otros[:subpartida] if otros[:subpartida]
     condiciones["subpartida_id"] = nil if otros[:subpartida] == "isnull"
     return condiciones
  end

  def self.condiciones_sin_proyecto moneda_id, agente_id, fecha_inicio, fecha_fin, agente_rol, partida_id, aprobado
     condiciones = {"fecha_inicio" => fecha_inicio..fecha_fin, "fecha_fin" => fecha_inicio..fecha_fin}
     condiciones["moneda_id"] = moneda_id unless moneda_id == "todas"
     condiciones[agente_rol + "_id"] = agente_id unless agente_id == "todos"
     condiciones["partida_id"] = partida_id if partida_id
     condiciones["proyecto_aprobado"] = aprobado if aprobado
     condiciones["convenio_accion"] = nil # que no sea un proyecto de tipo convenio
     return condiciones
  end

  # +++
  # Sobrecargamos la clase para incluir agrupaciones 
  # ---
  class << self

    # Devuelve un array de hashes con las actividades del proyecto agrupados para financiadores
    def agrupa_actividad_de_financiador proyecto_id, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio, partida_id=nil, columna_id=1
      pptos = actividad_de_financiador proyecto_id, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio, partida_id
      return pptos.collect {|p| {"columna_id" => columna_id.to_s, "importe" => p.importe , "fila_id" => p.fila_id }}
    end

    # Devuelve un array de hashes con las actividades del proyecto agrupados para implementadores 
    def agrupa_actividad_de_implementador proyecto_id, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio, partida_id=nil, columna_id=1
      pptos = actividad_de_implementador proyecto_id, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio, partida_id
      return pptos.collect {|p| {"columna_id" => columna_id.to_s, "importe" => p.importe , "fila_id" => p.fila_id }}
    end


    # Devuelve un array de hashes con los resultados del proyecto agrupados para financiadores
    def agrupa_resultado_de_financiador proyecto_id, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio, partida_id=nil, columna_id=1
      pptos_actividades = agrupa_actividad_de_financiador proyecto_id, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio, partida_id, columna_id
      pptos = []

      # Recorre todas las actividades generando los gastos por resultado
      pptos_actividades.each do |ppto|
        actividad = Actividad.find_by_id ppto["fila_id"]
        # Si no hay actividad ponemos nil y si la hay pero no tiene resultado_id ponemos 0 (acts. generales)
        resultado_id = actividad ? actividad.resultado_id||0 : nil 
        pptos = sum_array( pptos, {"columna_id" => columna_id.to_s, "importe" => ppto["importe"], "fila_id" => resultado_id} )
      end
      return pptos 
    end

    # Devuelve un array de hashes con los resultados del proyecto agrupados para financiadores
    def agrupa_resultado_de_implementador proyecto_id, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio, partida_id=nil, columna_id=1
      pptos_actividades = agrupa_actividad_de_implementador proyecto_id, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio, partida_id, columna_id
      pptos = []

      # Recorre todas las actividades generando los gastos por resultado
      pptos_actividades.each do |ppto|
        actividad = Actividad.find_by_id ppto["fila_id"]
        # Si no hay actividad ponemos nil y si la hay pero no tiene resultado_id ponemos 0 (acts. generales)
        resultado_id = actividad ? actividad.resultado_id||0 : nil 
        pptos = sum_array( pptos, {"columna_id" => columna_id.to_s, "importe" => ppto["importe"], "fila_id" => resultado_id} )
      end
      return pptos
    end

    # Devuelve un array de hashes con los oe del proyecto agrupados para financiadores
    def agrupa_oe_de_financiador proyecto_id, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio, partida_id=nil, columna_id=1
      pptos_resultados = agrupa_resultado_de_financiador proyecto_id, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio, partida_id, columna_id
      pptos = []

      # Recorre todos los resultados generando los gastos por oe 
      pptos_resultados.each do |ppto|
        # Se no habia resultado para la actividad era global, ponemos 0
        if ppto["fila_id"] == 0
          oe_id = 0
        # Si no era con resultado 0 puede que este huerfana de oe o que lo tenga
        else
          resultado = Resultado.find_by_id ppto["fila_id"]
          oe_id = resultado ? resultado.objetivo_especifico_id : nil
        end
        pptos = sum_array( pptos, {"columna_id" => columna_id.to_s, "importe" => ppto["importe"], "fila_id" => oe_id} )
      end
      return pptos 
    end

    # Devuelve un array de hashes con los oe del proyecto agrupados para financiadores
    def agrupa_oe_de_implementador proyecto_id, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio, partida_id=nil, columna_id=1
      pptos_resultados = agrupa_resultado_de_implementador proyecto_id, moneda_id, agente, fecha_inicio, fecha_fin, tasa_cambio, partida_id, columna_id
      pptos = []

      # Recorre todos los resultados generando los gastos por oe 
      pptos_resultados.each do |ppto|
        # Se no habia resultado para la actividad era global, ponemos 0
        if ppto["fila_id"] == 0
          oe_id = 0
        # Si no era con resultado 0 puede que este huerfana de oe o que lo tenga
        else
          resultado = Resultado.find_by_id ppto["fila_id"]
          oe_id = resultado ? resultado.objetivo_especifico_id : nil
        end
        pptos = sum_array( pptos, {"columna_id" => columna_id.to_s, "importe" => ppto["importe"], "fila_id" => oe_id} )
      end
      return pptos
    end

    # Metodos privados (suma elementos en el array principal)
    private
    def sum_array total, element
      found = false
      total.each do |el|
        if el["columna_id"] == element["columna_id"] && el["fila_id"] == element["fila_id"]
          el["importe"] += element["importe"]
          found = true
        end
      end
      total.push element unless found
      return total
    end

  end

end
