# encoding: UTF-8
#--
#
#################################################################################
# Copyright 2010-2013 Free Software's Seed, CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
# Controlador encargado de la visualización de GONG-R

require 'net/http'

class GongrAecidController < ApplicationController

  protect_from_forgery :except => :index

  def index
    # Capturamos las excepciones que se produzcan aqui por si no esta instalado el modulo
    #begin
      uri = 'http://proyectos.plexus.es/gong_r/'
      url = URI.parse( uri )

      # Genera la cabecera a enviar
      headers = { "Referrer" => uri, "Cookie" => "JSESSIONID=" + cookies[:JSESSIONID] + " Path=/gong_r" } if cookies[:JSESSIONID]
      # Obtiene la pagina a pedir
      peticion = /\/gongr_aecid(.+)/.match(request.url)
      pagina = peticion ? peticion[1] : '/'
      # Obtiene los parametros como un string
      unless request.request_parameters.empty?
        query_params = request.request_parameters.collect {|k,v| "#{k}=#{v}"} .join("&")
      end

      if request.get?
        # Hace la petición get
        result = Net::HTTP.start(url.host, url.port) {|http|
           mondrian_params = request.fullpath.match(/^\/gongr_aecid\/([^?]+)[?]+(.+)/)
           if mondrian_params
             #logger.info "---------------> Peticion:" + mondrian_params[1]
             #logger.info "---------------> Parametros: " + mondrian_params[2]
             http.send_request('GET', '/gong_r/' + mondrian_params[1], mondrian_params[2], headers)
           else
             #logger.info "--------------> GET: /gong_r" + pagina
             http.send_request('GET', '/gong_r' + pagina, query_params, headers)
           end
        }
      elsif request.post?
        # Hace la petición post 
        result = Net::HTTP.start(url.host, url.port) {|http|
          http.send_request('POST', '/gong_r',query_params, headers)
        }
      end

      # Guarda la cookie de la sesión para utilizarla en la navegacion de mondrian
      result.get_fields('set-cookie').each do |cookie|
        cookie_valor = cookie.sub(/JSESSIONID=(\w+);\sPath=\/gong_r/, '\1')
        cookies[:JSESSIONID] = { :value => cookie_valor } if cookie_valor
      end if result.get_fields('set-cookie')

      # Reescritura de URLs
      @salida = result.body
      puts "---------------> " + @salida.inspect

      # Parsea el codigo devuelto para cambiar las URLs
      #@salida = @salida.gsub(/href="/, 'href="/gongr_aecid/')
      @salida = @salida.gsub(/\/gong_r\/proyectos/, '/gongr_aecid/proyectos')
      # Imagenes y elementos estaticos, que se pidan directamente al mondrian via un proxy apache
      @salida = @salida.gsub(/\/gong_r\/img/, uri + "img")
      @salida = @salida.gsub(/\/gong_r\/scripts/, uri + "scripts") 
      @salida = @salida.gsub(/\/gong_r\/css/, uri + "css")
      @salida.force_encoding("UTF-8")
    #rescue
    #  msg_error _("Se produjo un error en el módulo de GONG-R. Contacte con el administrador del sistema.")
    #end
  end
end
