# encoding: UTF-8
#--
#
#################################################################################
# Copyright 2010-2013 Free Software's Seed, CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
# Controlador encargado del resumen inicial del usuario o el proyecto. Este controlador es utilizado desde las secciones:
# * Sección inicio: visualizar los datos relativos al usuario
# * Sección proyectos: visualizar y los datos relativos al proyecto

class InfoController  < ApplicationController

  before_filter :obtiene_proyectos


  # El metodo comprobar_periodo_identificador_financiador se encuentra en el ApplicationController
  before_filter :comprobar_periodo_identificador_financiador


  def index
    if @proyecto
      condiciones_tareas = ["estado_tarea.activo IS TRUE AND proyecto_id = ? AND (usuario_asignado_id IS NULL || usuario_asignado_id = ?)",@proyecto.id, @usuario_identificado.id]
       @periodos = @proyecto.periodo.find(:all, :order => ("fecha_inicio"))
    elsif @agente
      condiciones_tareas = ["estado_tarea.activo IS TRUE AND agente_id = ? AND (usuario_asignado_id IS NULL || usuario_asignado_id = ?)",@agente.id, @usuario_identificado.id]
    else
      condiciones_tareas = ["estado_tarea.activo IS TRUE AND ( (proyecto_id IN (?) && usuario_asignado_id IS NULL) || usuario_asignado_id = ? )",@usuario_identificado.proyecto, @usuario_identificado.id]
      condiciones_periodo = {}
      condiciones_periodo[:proyecto_id] = @usuario_identificado.proyecto unless @usuario_identificado.informes_aecid
      periodos = Periodo.find(:all, :order => ("fecha_inicio"), :conditions => condiciones_periodo) 
      # Seleccionamos los que sus tareas no estan cerradas (esto hay que repasarlo porque no funciona bien)
      @periodos = periodos.select {|p| (p.estado_abierto)}
      #@periodos = periodos.select {|p| !(p.estado_cerrado)} unless @usuario_identificado.informes_aecid
      #@periodos = periodos if @usuario_identificado.informes_aecid
    end
    @tareas = Tarea.find( :all, :conditions => condiciones_tareas, :include => [:tipo_tarea, :estado_tarea], :order => ("fecha_inicio"))
    render 'proyecto' if @proyecto
    render 'agente' if @agente
    render 'usuario' unless @proyecto || @agente 
  end

  def mas_proyectos
    render :update do |page|
      page.replace params[:update], :partial => 'proyectos'
    end
  end

 private

  def obtiene_proyectos
    @proyectos = @agente.proyecto_implementador.includes("definicion_estado").where("definicion_estado.aprobado" => true, "definicion_estado.cerrado" => false, "convenio_id" => nil) if @agente
    @proyectos = @usuario_identificado.proyecto.paginate(
      :conditions => ["NOT definicion_estado.cerrado"], :order => "definicion_estado.orden desc, proyecto.nombre", :include => "definicion_estado",
      :page => (params[:page] || 1), :per_page => 3) unless @proyecto || @agente
  end
end
