# encoding: UTF-8
#--
#
#################################################################################
# Copyright 2010-2013 Free Software's Seed, CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
# cuenta contable 

class CuentaContable < ActiveRecord::Base
  # Esto nos permite obtener el elemento (proyecto, agente, ...)  haciendo codigo_contable.contabilidad
  belongs_to :elemento_contable, polymorphic: true
  # Esta es la delegacion a la que pertenecen los codigos contables
  belongs_to :delegacion, :class_name => "Agente", :foreign_key => "agente_id"

  # Para poder hacer joins...
  scope :by_type, lambda { |type| joins("JOIN #{type.table_name} ON #{type.table_name}.id = #{CuentaContable.table_name}.elemento_contable_id AND #{CuentaContable.table_name}.elemento_contable_type = '#{type.to_s}'") }

  validates_presence_of :codigo, :message => _("Código") + " " + _("no puede estar vacío.")
  validates_presence_of :elemento_contable_type, :message => _("Tipo de subcuenta") + " " + _("no puede estar vacío.")
  #validates_presence_of :elemento_contable_id, :message => _("Elemento Contable") + " " + _("no puede estar vacío.")
  # Dejamos el codigo unico para cada delegacion (no impedimos -de momento- que no exista una)...
  validates_uniqueness_of :codigo, :scope => [:agente_id,:centro_coste], :message => _("Código repetido.")

  def esta_vinculado?
    return !elemento_contable.nil?
  end
end
