# encoding: UTF-8
#--
#
#################################################################################
# Copyright 2010-2013 Free Software's Seed, CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
class Ingreso < ActiveRecord::Base
  
  #untranslate_all
  belongs_to :libro
  
  validates_presence_of :importe, :message => _("Importe") +  " " + _("no puede estar vacío.")
  validates_presence_of :moneda_id, :message => _("Moneda") +  " " + _("no puede estar vacía.")
  validates_presence_of :libro_id, :message => _("Cuenta") + " " + _("no puede estar vacía.")
  validates_presence_of :agente_id, :message => _("Agente") +  " " + _("no puede estar vacío.")
  validates_presence_of :fecha, :message => _("Fecha") + " " + _("no puede estar vacía.")

  # Comprueba que la fecha está dentro de la etapa seleccionada.
  def comprobar_fecha_etapa etapa
    if self.fecha > etapa.fecha_inicio and self.fecha < etapa.fecha_fin
      return true
    else
      errors.add(_("Fecha"), _("La fecha debe estar dentro de la etapa")) ; return false
    end
  end
  

end
