# encoding: UTF-8
#--
#
#################################################################################
# Copyright 2010-2013 Free Software's Seed, CENATIC y IEPALA
#
# Licencia con arreglo a la EUPL, Versión 1.1 o –en cuanto sean aprobadas por la Comisión Europea– 
# versiones posteriores de la EUPL (la «Licencia»);
# Solo podrá usarse esta obra si se respeta la Licencia.
# Puede obtenerse una copia de la Licencia en:
#
# http://www.osor.eu/eupl/european-union-public-licence-eupl-v.1.1
#
# Salvo cuando lo exija la legislación aplicable o se acuerde por escrito, 
# el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
# SIN GARANTÍAS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
# Véase la Licencia en el idioma concreto que rige los permisos y limitaciones que establece la Licencia.
#################################################################################
#
#++
class VPresupuesto < ActiveRecord::Base
  #untranslate_all
  scope :partida_implementador, lambda { |*valores| {
                                 :select => "partida_id as fila_id, implementador_id as columna_id, #{importe valores[2], valores[3]} as importe", 
                                 :group => "proyecto_id, #{valores[1] == "todas" ? "" : " etapa_id, "} #{valores[2] == "todas" ? "" : " moneda_id, "} partida_id, implementador_id",
                                 :conditions => condiciones(valores[0], valores[1], valores[2])  } }

  scope :partida_financiador, lambda { |*valores| {
                                 :select => "partida_id as fila_id, financiador_id as columna_id, #{importe valores[2], valores[3]} as importe", 
                                 :group => "proyecto_id,  #{valores[1] == "todas" ? "" : " etapa_id, "} #{valores[2] == "todas" ? "" : " moneda_id, "} partida_id, financiador_id",
                                 :conditions => condiciones(valores[0], valores[1], valores[2])  } }


  scope :actividad_implementador, lambda { |*valores| {
                                 :select => "actividad_id as fila_id, implementador_id as columna_id, #{importe valores[2], valores[3]} as importe", 
                                 :group => "proyecto_id,  #{valores[1] == "todas" ? "" : " etapa_id, "}  #{valores[2] == "todas" ? "" : " moneda_id, "} actividad_id, implementador_id",
                                 :conditions => condiciones(valores[0], valores[1], valores[2])  } }

  # valores[0] -> proyecto_id
  # valores[1] -> etapa_id (admite "todas")
  # valores[2] -> moneda_id (admite "todas")
  # valores[3] -> tasa_de_cambio ("0": no convierte a moneda base, "1": convierte a moneda base)
  scope :actividad_financiador, lambda { |*valores| {
                                 :select => "actividad_id as fila_id, financiador_id as columna_id, #{importe valores[2], valores[3]} as importe", 
                                 :group => "proyecto_id,  #{valores[1] == "todas" ? "" : " etapa_id, "} #{valores[2] == "todas" ? "" : " moneda_id, "} actividad_id, financiador_id",
                                 :conditions => condiciones(valores[0], valores[1], valores[2]) } }

  scope :partida_proyecto_implementador, lambda { |*valores| {
                                 :select => "partida_proyecto_id as fila_id, implementador_id as columna_id, #{importe valores[2], valores[3]} as importe", 
                                 :group => "proyecto_id, #{valores[1] == "todas" ? "" : " etapa_id, "} #{valores[2] == "todas" ? "" : " moneda_id, "} partida_proyecto_id, implementador_id",
                                 :conditions => condiciones(valores[0], valores[1], valores[2])  } }

                                    
  scope :partida_proyecto_financiador, lambda { |*valores| {
                                 :select => "partida_proyecto_id as fila_id, financiador_id as columna_id, #{importe valores[2], valores[3]} as importe", 
                                 :group => "proyecto_id,  #{valores[1] == "todas" ? "" : " etapa_id, "} #{valores[2] == "todas" ? "" : " moneda_id, "} partida_proyecto_id, financiador_id",
                                 :conditions => condiciones(valores[0], valores[1], valores[2]) } }

  # valores[0] -> proyecto_id
  # valores[1] -> etapa_id (admite "todas")
  # valores[2] -> moneda_id (admite "todas")
  # valores[3] -> tasa_de_cambio ("0": no convierte a moneda base, "1": convierte a moneda base)
  # valores[4] -> financiador_id
  # valores[5] -> columna_id (arbitrario)
  scope :actividad_financiador_agrupado, lambda { |*valores| {
                                 :select => "actividad_id as fila_id, #{valores[5]} as columna_id, #{importe valores[2], valores[3]} as importe",
                                 :group => "proyecto_id,  #{valores[1] == "todas" ? "" : " etapa_id, "} #{valores[2] == "todas" ? "" : " moneda_id, "} actividad_id",
                                 :conditions => condiciones(valores[0], valores[1], valores[2], :financiador => valores[4]) } }

  scope :partida_financiador_agrupado, lambda { |*valores| {
                                 :select => "partida_id as fila_id, #{valores[5]} as columna_id, #{importe valores[2], valores[3]} as importe",
                                 :group => "proyecto_id,  #{valores[1] == "todas" ? "" : " etapa_id, "} #{valores[2] == "todas" ? "" : " moneda_id, "} partida_id",
                                 :conditions => condiciones(valores[0], valores[1], valores[2], :financiador => valores[4]) } }

  scope :partida_proyecto_financiador_agrupado, lambda { |*valores| {
                                 :select => "partida_proyecto_id as fila_id, #{valores[5]} as columna_id, #{importe valores[2], valores[3]} as importe",
                                 :group => "proyecto_id,  #{valores[1] == "todas" ? "" : " etapa_id, "} #{valores[2] == "todas" ? "" : " moneda_id, "} partida_proyecto_id",
                                 :conditions => condiciones(valores[0], valores[1], valores[2], :financiador => valores[4]) } }

     
  scope :financiador, lambda { |*valores| {
                                 :select => "#{importe 'todas', '1' } as importe", 
                                 #:group => "proyecto_id, etapa_id, #{valores[2] == "todas" ? "" : " moneda_id, "} partida_id, implementador_id",
                                 :conditions => {"proyecto_id" => valores[0], "financiador_id" => valores[1] }  } }

  scope :subpartida_partida, lambda { |*valores| {
                                 :select => "#{importe valores[2], valores[3] } as importe", 
                                 #:group => "proyecto_id, etapa_id, #{valores[2] == "todas" ? "" : " moneda_id, "} partida_id, implementador_id",
                                 :conditions => condiciones( valores[0], valores[1], valores[2], :partida => valores[4], :subpartida => (valores[5] || "isnull") ) } }

  scope :subpartida_partida_proyecto, lambda { |*valores| {
                                 :select => "#{importe valores[2], valores[3] } as importe", 
                                 #:group => "proyecto_id, etapa_id, #{valores[2] == "todas" ? "" : " moneda_id, "} partida_id, implementador_id",
                                 :conditions => condiciones( valores[0], valores[1], valores[2], :partida_proyecto => valores[4], :subpartida => (valores[5] || "isnull") ) } }

  scope :partida, lambda { |*valores| {
                                 :select => "#{importe valores[2], valores[3] } as importe", 
                                 #:group => "proyecto_id, etapa_id, #{valores[2] == "todas" ? "" : " moneda_id, "} partida_id, implementador_id",
                                 :conditions => condiciones( valores[0], valores[1], valores[2], :partida => valores[4] ) } }

  scope :partida_proyecto, lambda { |*valores| {
                                 :select => "#{importe valores[2], valores[3] } as importe", 
                                 #:group => "proyecto_id, etapa_id, #{valores[2] == "todas" ? "" : " moneda_id, "} partida_id, implementador_id",
                                 :conditions => condiciones( valores[0], valores[1], valores[2], :partida_proyecto => valores[4] ) } }

  def self.importe moneda_id, tasa_cambio
    importe = if  moneda_id == "todas";  "sum(importe_moneda_base)"
               elsif tasa_cambio == "0"; "sum(importe)"
               elsif tasa_cambio == "1"; "sum(importe_moneda_base)"; end
  end  

  def self.condiciones proyecto_id, etapa_id, moneda_id, otros={}
     condiciones = {"proyecto_id" => proyecto_id} 
     condiciones["etapa_id"] = etapa_id unless etapa_id == "todas"
     condiciones["moneda_id"] = moneda_id unless moneda_id == "todas"
     condiciones["partida_id"] = otros[:partida] if otros[:partida]
     condiciones["partida_proyecto_id"] = otros[:partida_proyecto] if otros[:partida_proyecto]
     condiciones["financiador_id"] = otros[:financiador] if otros[:financiador]
     condiciones["subpartida_id"] = otros[:subpartida] if otros[:subpartida]
     condiciones["subpartida_id"] = nil if otros[:subpartida] == "isnull"
     return condiciones
  end


 # +++
 # Sobrecargamos la clase para incluir agrupaciones 
 # ---
 class << self

  # Para agrupaciones de datos, tenemos que construir la tabla columna a columna
  def partida_financiador_x_grupos proyecto_id, etapa_id, moneda_id, tasa_cambio
    proyecto = Proyecto.find_by_id proyecto_id
    datos = []
    # Informacion del financiador principal
    datos += partida_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.agente.id, 0
    # Otras aportaciones publicas externas
    datos += partida_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_externo_publico, 1
    # ONG/Agrupacion externa
    datos += partida_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_externo_ong, 2
    # Otras aportaciones privadas externas
    datos += partida_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_externo_privado, 3
    # ONG Local
    datos += partida_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_local_ong, 4
    # Aportaciones publicas locales
    datos += partida_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_local_publico, 5
    # Aportaciones privadas locales
    datos += partida_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_local_privado, 6
    return [columnas_financiador_agrupado(proyecto), datos]
  end

  def partida_proyecto_financiador_x_grupos proyecto_id, etapa_id, moneda_id, tasa_cambio
    proyecto = Proyecto.find_by_id proyecto_id
    datos = []
    # Informacion del financiador principal
    datos += partida_proyecto_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.agente.id, 0
    # Otras aportaciones publicas externas
    datos += partida_proyecto_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_externo_publico, 1
    # ONG/Agrupacion externa
    datos += partida_proyecto_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_externo_ong, 2
    # Otras aportaciones privadas externas
    datos += partida_proyecto_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_externo_privado, 3
    # ONG Local
    datos += partida_proyecto_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_local_ong, 4
    # Aportaciones publicas locales
    datos += partida_proyecto_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_local_publico, 5
    # Aportaciones privadas locales
    datos += partida_proyecto_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_local_privado, 6

    return [columnas_financiador_agrupado(proyecto), datos]
  end

  def actividad_financiador_x_grupos proyecto_id, etapa_id, moneda_id, tasa_cambio
    proyecto = Proyecto.find_by_id proyecto_id
    datos = []
    # Informacion del financiador principal
    datos += actividad_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.agente.id, 0
    # Otras aportaciones publicas externas
    datos += actividad_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_externo_publico, 1
    # ONG/Agrupacion externa
    datos += actividad_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_externo_ong, 2
    # Otras aportaciones privadas externas
    datos += actividad_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_externo_privado, 3
    # ONG Local
    datos += actividad_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_local_ong, 4
    # Aportaciones publicas locales
    datos += actividad_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_local_publico, 5
    # Aportaciones privadas locales
    datos += actividad_financiador_agrupado proyecto.id, etapa_id, moneda_id, tasa_cambio, proyecto.financiador_local_privado, 6

    return [columnas_financiador_agrupado(proyecto), datos]
  end

  # Devuelve un array de hashes con las actividades del convenio agrupadas (correccion para convenios) para financiadores
  def agrupa_actividad_de_financiador proyecto_id, etapa_id, moneda_id, tasa_cambio, agente_id, columna_id=2
    unless proyecto_id.class.name=="Fixnum" || proyecto_id.class.name=="Proyecto"
      pacs = proyecto_id if proyecto_id.first.class.name == "Proyecto"
      proyecto = pacs.first.convenio if pacs
    else
      pacs = nil
      proyecto = Proyecto.find_by_id(proyecto_id)
    end

    # Si estamos con un convenio, devolvemos los agrupados segun las partidas de financiacion del convenio (no de los pacs)
    if (pacs)
      p = actividad_financiador_agrupado pacs.collect{|p| p.id}, etapa_id, moneda_id, tasa_cambio, agente_id, columna_id
      pptos = []
      p.each do |a|
        # Hacemos el mapeo del mapeo de actividades
        actividad_proyecto = Actividad.find_by_id(a.fila_id)
        actividad_convenio = actividad_proyecto ? proyecto.actividad.find_by_id(actividad_proyecto.actividad_convenio_id) : nil
        pptos = sum_array( pptos, { "columna_id" => columna_id.to_s, "importe" => a.importe , "fila_id" => (actividad_convenio ? actividad_convenio.id : nil) } )
      end
    else
      p = actividad_financiador_agrupado proyecto_id, etapa_id, moneda_id, tasa_cambio, agente_id , columna_id
      pptos = p.collect {|a| {"columna_id" => columna_id.to_s, "importe" => a.importe , "fila_id" => a.fila_id }}
    end

    return pptos
  end

  # Devuelve un array de hashes con los resultados del proyecto agrupados para financiadores (usa la correccion para convenios de agrupa_actividad_de_financiador)
  def agrupa_resultado_de_financiador proyecto_id, etapa_id, moneda_id, tasa_cambio, agente_id, columna_id=2
    pptos_actividades = agrupa_actividad_de_financiador proyecto_id, etapa_id, moneda_id, tasa_cambio, agente_id, columna_id 
    pptos = []

    # Recorre todas las actividades generando los gastos por resultado
    pptos_actividades.each do |ppto|
      actividad = Actividad.find_by_id ppto["fila_id"]
      # Si no hay actividad ponemos nil y si la hay pero no tiene resultado_id ponemos 0 (acts. generales)
      resultado_id = actividad ? actividad.resultado_id||0 : nil
      pptos = sum_array( pptos, {"columna_id" => columna_id.to_s, "importe" => ppto["importe"], "fila_id" => resultado_id} ) 
    end
    return pptos 
  end

  # Devuelve un array de hashes con los oe del proyecto agrupados para financiadores (usa la correccion para convenios de agrupa_actividad_de_financiador)
  def agrupa_oe_de_financiador proyecto_id, etapa_id, moneda_id, tasa_cambio, agente_id, columna_id=2 
    pptos_resultados = agrupa_resultado_de_financiador proyecto_id, etapa_id, moneda_id, tasa_cambio, agente_id, columna_id 
    pptos = []

    # Recorre todos los resultados generando los pptos por oe 
    pptos_resultados.each do |ppto|
      # Se no habia resultado para la actividad era global, ponemos 0
      if ppto["fila_id"] == 0
        oe_id = 0
      # Si no era con resultado 0 puede que este huerfana de oe o que lo tenga
      else
        resultado = Resultado.find_by_id ppto["fila_id"]
        oe_id = resultado ? resultado.objetivo_especifico_id : nil
      end
      pptos = sum_array( pptos, {"columna_id" => columna_id.to_s, "importe" => ppto["importe"], "fila_id" => oe_id} )
    end
    return pptos 
  end

  def columnas_financiador_agrupado proyecto
    return [
		{"id" => 0, "nombre" => proyecto.agente.nombre},
		{"id" => 1, "nombre" => _("Otras Aportaciones Públicas Externas")},
		{"id" => 2, "nombre" => _("ONG/Agrupación")},
		{"id" => 3, "nombre" => _("Otras Aportaciones Privadas Externas")},
		{"id" => 4, "nombre" => _("ONG Local")},
		{"id" => 5, "nombre" => _("Aportaciones Públicas Locales")},
		{"id" => 6, "nombre" => _("Población Beneficiaria/Aportaciones Privadas")}
           ]
  end

  # Metodos privados (suma elementos en el array principal)
  private
  def sum_array total, element
    found = false
    total.each do |el|
      if el["columna_id"] == element["columna_id"] && el["fila_id"] == element["fila_id"]
        el["importe"] += element["importe"]
        found = true
      end
    end
    total.push element unless found
    return total
  end

 end

end
